Index: squid/src/fs/ufs/store_dir_ufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/ufs/store_dir_ufs.c,v
retrieving revision 1.5.4.1
retrieving revision 1.5.4.1.6.1
diff -u -r1.5.4.1 -r1.5.4.1.6.1
--- squid/src/fs/ufs/store_dir_ufs.c	17 Dec 2000 08:20:06 -0000	1.5.4.1
+++ squid/src/fs/ufs/store_dir_ufs.c	17 Dec 2000 14:36:24 -0000	1.5.4.1.6.1
@@ -862,6 +862,10 @@
     char *new_path = xstrdup(storeUfsDirSwapLogFile(sd, ".new"));
     int fd;
     file_close(ufsinfo->swaplog_fd);
+    if( sd -> flags.offline )
+      {
+	return;
+      }
 #ifdef _SQUID_OS2_
     if (unlink(swaplog_path) < 0) {
 	debug(50, 0) ("%s: %s\n", swaplog_path, xstrerror());
@@ -893,6 +897,10 @@
     struct stat clean_sb;
     FILE *fp;
     int fd;
+    if( sd -> flags.offline )
+      {
+	return;
+      }
     if (stat(swaplog_path, &log_sb) < 0) {
 	debug(47, 1) ("Cache Dir #%d: No log file\n", sd->index);
 	safe_free(swaplog_path);
@@ -952,6 +960,11 @@
 {
     struct _clean_state *state = xcalloc(1, sizeof(*state));
     struct stat sb;
+
+    if( sd -> flags.offline )
+      {
+	return;
+      }
     sd->log.clean.write = NULL;
     sd->log.clean.state = NULL;
     state->new = xstrdup(storeUfsDirSwapLogFile(sd, ".clean"));
@@ -1001,6 +1014,11 @@
     storeSwapLogData s;
     static size_t ss = sizeof(storeSwapLogData);
     struct _clean_state *state = sd->log.clean.state;
+
+    if( sd -> flags.offline )
+      {
+	return;
+      }
     memset(&s, '\0', ss);
     s.op = (char) SWAP_LOG_ADD;
     s.swap_filen = e->swap_filen;
@@ -1035,6 +1053,8 @@
 storeUfsDirWriteCleanDone(SwapDir * sd)
 {
     struct _clean_state *state = sd->log.clean.state;
+    if (sd->flags.offline)
+	return;
     if (NULL == state)
 	return;
     if (state->fd < 0)
@@ -1095,7 +1115,10 @@
 storeUfsDirSwapLog(const SwapDir * sd, const StoreEntry * e, int op)
 {
     ufsinfo_t *ufsinfo = (ufsinfo_t *) sd->fsdata;
-    storeSwapLogData *s = memAllocate(MEM_SWAP_LOG_DATA);
+    storeSwapLogData *s;
+    if (sd->flags.offline)
+	return;
+    s = memAllocate(MEM_SWAP_LOG_DATA);
     s->op = (char) op;
     s->swap_filen = e->swap_filen;
     s->timestamp = e->timestamp;
@@ -1118,6 +1141,10 @@
 static void
 storeUfsDirNewfs(SwapDir * sd)
 {
+    if( sd -> flags.offline )
+      {
+	return;
+      }
     debug(47, 3) ("Creating swap space in %s\n", sd->path);
     storeUfsDirCreateDirectory(sd->path, 0);
     storeUfsDirCreateSwapSubDirs(sd);
@@ -1153,6 +1180,10 @@
     N0 = n_ufs_dirs;
     D0 = ufs_dir_index[swap_index % N0];
     SD = &Config.cacheSwap.swapDirs[D0];
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     ufsinfo = (ufsinfo_t *) SD->fsdata;
     N1 = ufsinfo->l1;
     D1 = (swap_index / N0) % N1;
@@ -1229,6 +1260,10 @@
 	ufs_dir_index = xcalloc(n_ufs_dirs, sizeof(*ufs_dir_index));
 	for (i = 0, n = 0; i < Config.cacheSwap.n_configured; i++) {
 	    sd = &Config.cacheSwap.swapDirs[i];
+	    if( sd -> flags.offline )
+	      {
+		continue;
+	      }
 	    if (!storeUfsDirIs(sd))
 		continue;
 	    ufs_dir_index[n++] = i;
@@ -1309,6 +1344,10 @@
     double f;
     RemovalPurgeWalker *walker;
     /* We can't delete objects while rebuilding swap */
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     if (store_dirs_rebuilding) {
 	return;
     } else {
@@ -1356,6 +1395,10 @@
 	return -1;
     }
 #endif
+    if( SD -> flags.offline )
+      {
+	return -1;
+      }
     /* Return 999 (99.9%) constant load */
     return 999;
 }
@@ -1371,6 +1414,10 @@
 {
     debug(1, 3) ("storeUfsDirRefObj: referencing %p %d/%d\n", e, e->swap_dirn,
 	e->swap_filen);
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     if (SD->repl->Referenced)
 	SD->repl->Referenced(SD->repl, e, &e->repl);
 }
@@ -1385,6 +1432,10 @@
 {
     debug(1, 3) ("storeUfsDirUnrefObj: referencing %p %d/%d\n", e, e->swap_dirn,
 	e->swap_filen);
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     if (SD->repl->Dereferenced)
 	SD->repl->Dereferenced(SD->repl, e, &e->repl);
 }
@@ -1401,6 +1452,10 @@
 {
     debug(79, 3) ("storeUfsDirUnlinkFile: unlinking fileno %08X\n", f);
     /* storeUfsDirMapBitReset(SD, f); */
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     unlinkdUnlink(storeUfsDirFullPath(SD, f, NULL));
 }
 
@@ -1414,6 +1469,10 @@
 {
     debug(20, 4) ("storeUfsDirReplAdd: added node %p to dir %d\n", e,
 	SD->index);
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     SD->repl->Add(SD->repl, e, &e->repl);
 }
 
@@ -1424,6 +1483,10 @@
     SwapDir *SD = INDEXSD(e->swap_dirn);
     debug(20, 4) ("storeUfsDirReplRemove: remove node %p from dir %d\n", e,
 	SD->index);
+    if( SD -> flags.offline )
+      {
+	return;
+      }
     SD->repl->Remove(SD->repl, e, &e->repl);
 }
 
@@ -1494,6 +1557,10 @@
     int l2;
     unsigned int read_only = 0;
 
+    if( sd -> flags.offline )
+      {
+	return;
+      }
     i = GetInteger();
     size = i << 10;		/* Mbytes to kbytes */
     if (size <= 0)
@@ -1529,13 +1596,13 @@
 storeUfsDirDump(StoreEntry * entry, const char *name, SwapDir * s)
 {
     ufsinfo_t *ufsinfo = (ufsinfo_t *) s->fsdata;
-    storeAppendPrintf(entry, "%s %s %s %d %d %d\n",
+    storeAppendPrintf(entry, "%s %s %s %d %d %d [%s]\n",
 	name,
 	"ufs",
 	s->path,
 	s->max_size >> 10,
 	ufsinfo->l1,
-	ufsinfo->l2);
+	ufsinfo->l2, s -> flags.offline ? "offline" : "online");
 }
 
 /*
@@ -1582,6 +1649,8 @@
 storeUfsCleanupDoubleCheck(SwapDir * sd, StoreEntry * e)
 {
     struct stat sb;
+    if (sd->flags.offline)
+	return -1;
     if (stat(storeUfsDirFullPath(sd, e->swap_filen, NULL), &sb) < 0) {
 	debug(20, 0) ("storeUfsCleanupDoubleCheck: MISSING SWAP FILE\n");
 	debug(20, 0) ("storeUfsCleanupDoubleCheck: FILENO %08X\n", e->swap_filen);
